 program

  Map
    Module('Windows API')
      GetTempPath(ULONG,*CSTRING),RAW,ULONG,PROC,PASCAL,NAME('GetTempPathA')
    end
  end

  Include('jsredir.inc')

Entry1        String(255)
FoundPathName String(255)
FoundString   String(30)
Redirstring   String(1000)
Suggest       Byte
RedFile       CString(255)
Window WINDOW('Redirection Test'),AT(,,267,209),FONT('MS Sans Serif',8,,),CENTER,SYSTEM,GRAY,DOUBLE
       PROMPT('Select File:'),AT(7,5),USE(?Prompt1)
       ENTRY(@s255),AT(47,5,169,10),USE(Entry1)
       BUTTON('...'),AT(220,5,10,10),USE(?LookupFile),TIP('This button looks up a file, and returns the "relative path", if possible, as co' &|
           'mpared to the "fully redurced" filename.')
       BUTTON('...'),AT(232,5,10,10),USE(?LookupFileReduced),TIP('This button looks up the file and returns the fully "reduced" filename.')
       STRING(@s255),AT(47,18),USE(FoundPathName)
       STRING(@s30),AT(47,27),USE(FoundString)
       BUTTON('Reload Redirection File'),AT(3,38,85,14),USE(?ReloadButton)
       BUTTON('Unload Redirection File'),AT(91,38,85,14),USE(?UnloadButton)
       BUTTON('Edit Redirection File'),AT(179,38,85,14),USE(?EditButton)
       CHECK('Suggest Path (This is used if the file doesn''t yet exist. '),AT(10,54,187,14),USE(Suggest), |
           TIP('Suggest Path (This is used if the file doesn''t yet exist. That way, you can crea' &|
           'te the file using the "suggested" filename if desired.)')
       GROUP('STRING for loading into redir'),AT(4,70,259,122),USE(?Group1),BOXED
         PROMPT(''),AT(9,78,249,33),USE(?TextBoxPrompt)
         TEXT,AT(9,114,249,58),USE(RedirString),VSCROLL,FONT('Fixedsys',9,,FONT:regular,CHARSET:ANSI)
         BUTTON('Load contents of textbox into redirection object'),AT(9,174,249,14),USE(?LoadFromTextButton)
       END
       BUTTON('&Close'),AT(219,194,45,14),USE(?CloseButton),STD(std:close)
     END

JSR  Class(JSRedirClass)
AddDefaultMacros   Procedure,Derived
     end

   Code

  RedirString = '*.* = %TEMP%'           !See the AddDefaultMacros() derived method at the bottom of this source file for how the %TEMP% macro was added.

  RedFile = '.\Test.Red'                 !Initialize the variable holding the name of a redirection file

  JSR.ParseRedirFile(RedFile,'Common',1) !Parses the redirection file for use in the class.
                                         !The "Common" parameter specifies the section of the redirection to be parsed.
                                         !The last parameter is boolean, specifying that we want to verify that the paths exist. If zero or FALSE is passed, or the parameter is omitted, then no validation occurs.
                                         !**NOTE** You could call this method multiple times with multiple Redirection files. This might
                                         !         be handy when there is a "main" redirection file(s) in the application folder, but the user could
                                         !         have his/her own redirection file(s) on his/her own machine.


  Entry1 = 'test.txt'                    !Initialize the filename to "test.txt".
  Open(Window)
  ?TextBoxPrompt{PROP:Text} = 'You can also load redirection information from a STRING.    ' &|
                'For the sake of this demo, a %TEMP% macro has been added. Try putting something like "*.* = %TEMP% " in this text box:' &|
                'Then press the "load" button below.   If the file doesn''t exist, try clicking the "suggest" checkbox.'

  Post(Event:Accepted,?Entry1)
  Accept
    Case Accepted()
    of ?LookupFile
      If JSR.FileDialog('Look up File',Entry1,'Text Files|*.txt',FILE:LongName+FILE:NoError,1) !This is just like the standard Clarion file dialog, except that it has one more parameter with the option to return only the relative path.
        Select(?Entry1)
      end
      Post(Event:Accepted,?Entry1)
    of ?LookupFileReduced
      If JSR.FileDialog('Look up File',Entry1,'Text Files|*.txt',FILE:LongName+FILE:NoError,0) !This is just like the standard Clarion file dialog, except that it has one more parameter with the option to return only the relative path.
        Select(?Entry1)
      end
      Post(Event:Accepted,?Entry1)
    of ?EditButton
      Run('Notepad '& RedFile )
    of ?ReloadButton
      JSR.Reset                          !Clears out any previously parsed redirection files from memory.
      JSR.ParseRedirFile(RedFile,'Common',1) !Parse the file again.
      Post(Event:Accepted,?Entry1)
    of ?LoadFromTextButton
      If Message('Would you like to unload any previous redirection info first?||(NOTE: This message shows in this demo only. It is not part of the class..)','Load Redir from Text',ICON:Exclamation,Button:Yes+Button:No,Button:Yes)=Button:Yes
        JSR.Reset                          !Clears out any previously parsed redirection files from memory.
      end
      JSR.ParseRedirString(Redirstring,1) !Reads the redirection from a STRING instead of a file. Otherwise, it works the same way.
      Post(Event:Accepted,?Entry1)
    of ?UnloadButton
      JSR.Reset                          !Clears out any previously parsed redirection files from memory.
      Post(Event:Accepted,?Entry1)
    of ?Entry1
      FoundString = Choose(JSR.FindFilePath(Entry1,FoundPathName,Suggest)=1,'Found in Redir! :-)','Not Found in Redir :-(......') !Using the information that was parsed from the redirection file, we try to locate the file.

        !**NOTE** If the FindFilePath() method returns TRUE, then it means that the file was located, and it is now safe to use the FoundPathName
        !         variable to reference the file.

      Display(?FoundPathName)
    of ?Suggest
      Post(Event:Accepted,?Entry1)
    end
  end


JSR.AddDefaultMacros  Procedure !This is a demonstration of how you could override the AddDefaultMacros method and add your own macros.
TempPath CString(FILE:MaxFilePath+1)

  Code

  PARENT.AddDefaultMacros                !Calls the PARENT (optional)
  GetTempPath(FILE:MaxFilePath,TempPath) !Find the windows temp folder
  SELF.AddMacro('TEMP',TempPath)         !Add the %TEMP% macro, which will now refer to wherever folder your windows TEMP is located.
  !Add any other macros here using SELF.AddMacro()